=== debian/changelog ===
spfft (1.1.0-1build2) plucky; urgency=medium

  * No-change rebuild for openmpi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 30 Nov 2024 08:03:57 +0100

spfft (1.1.0-1build1) oracular; urgency=medium

  * No-change rebuild against mpi-defaults 1.17

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Thu, 01 Aug 2024 09:04:07 -0700

spfft (1.1.0-1) unstable; urgency=medium

  * New upstream version 1.1.0
  * Fix debian/watch.
  * Bump copyright year.
  * Drop superfluous copyright stanza.

 -- Andrius Merkys <merkys@debian.org>  Thu, 20 Jun 2024 03:39:27 -0400
