## spfft 1.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.18 FATAL_ERROR) # 3.18 for C++17
-project(SpFFT LANGUAGES CXX VERSION 1.1.0)
+project(SpFFT LANGUAGES CXX VERSION 1.1.1)
 set(SPFFT_SO_VERSION 1)
 set(SPFFT_VERSION ${PROJECT_VERSION})
