=== debian/changelog ===
spfft (1.1.1-4) unstable; urgency=medium

  * Remove hardcoded clang++ version from debian/rules (Closes: #1118976)

 -- Andrius Merkys <merkys@debian.org>  Mon, 27 Oct 2025 04:22:45 -0400

spfft (1.1.1-3) unstable; urgency=medium

  * Fix co-installation failure of libspfft-dev (Closes: #1100920).
    Thanks Helmut Grohne.

 -- Andrius Merkys <merkys@debian.org>  Thu, 20 Mar 2025 11:31:09 -0400

spfft (1.1.1-2) unstable; urgency=medium

  [ Utkarsh Raj ]
  * Set SPFFT_GPU_BACKEND=ROCM for amd64, arm64, ppc64el.
  * Add ROCm build dependencies, limited to amd64, arm64, ppc64el.
  * Build for all supported GPU architectures. 

 -- Andrius Merkys <merkys@debian.org>  Tue, 18 Mar 2025 12:16:21 -0400

spfft (1.1.1-1) unstable; urgency=medium

  * New upstream version 1.1.1
  * Bump copyright years.
  * Remove RUNPATH setting with chrpath.

 -- Andrius Merkys <merkys@debian.org>  Thu, 23 Jan 2025 07:10:46 -0500
