=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%spfft-$1.tar.gz%" \
 https://github.com/eth-cscs/SpFFT/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
